library ieee;
use ieee.std_logic_1164.all;

package functions is
  function NaturalToSLV (NaturalValue: natural; Size: natural) return std_logic_vector;
  function SLVtoNatural (SLV: std_logic_vector) return natural;
end functions;

library ieee;
use ieee.std_logic_1164.all;

package body functions is

--     std_logic_vector
function NaturalToSLV (NaturalValue: natural; Size: natural) return std_logic_vector is
  variable TempNatural: natural;
  variable result : std_logic_vector(Size - 1 downto 0);
begin
  TempNatural := NaturalValue;
  for i in 0 to Size - 1 loop
      if TempNatural rem 2 = 1 then result(i) := '1'; else result(i) := '0'; end if;
      TempNatural := TempNatural / 2;
  end loop;
  return result;
end NaturalToSLV;

--  std_logic_vector    
function SLVtoNatural (SLV: std_logic_vector) return natural is
  variable result : natural;
begin
  result := 0;
  for i in 0 to SLV'length - 1 loop
    if SLV(i) = '1' then result := result + 2**i; end if;
  end loop;
  return result;
end SLVtoNatural;

end functions;
