library ieee;
use ieee.std_logic_1164.all;
entity tbCounter is
end tbCounter;

architecture behavioral of tbCounter is
    constant SYSCLK_PERIOD : time := 100 ns;
    signal SYSCLK : std_logic := '0';
    signal SYSRESET : std_logic := '0';

    component counter
        port( 
            clock : in std_logic;
            reset : in std_logic;
            code : out std_logic_vector(3 downto 0)
        );
    end component;

begin
    process
        variable vhdl_initial : BOOLEAN := TRUE;
    begin
        if ( vhdl_initial ) then
            -- Assert Reset
            SYSRESET <= '1';
            wait for ( SYSCLK_PERIOD * 10 );
            SYSRESET <= '0';
            wait;
        end if;
    end process;
    -- 10MHz Clock Driver
    SYSCLK <= not SYSCLK after (SYSCLK_PERIOD / 2.0 );
    -- Instantiate Unit Under Test:  counter
    counter_0 : counter
        -- port map
        port map( 
            clock => SYSCLK,
            reset => SYSRESET,
            code => open
        );

end behavioral;

